/****************************************************************************
*
*	  Header Filename:  Krnl_Ctrl.h
*	  Module Name:      Kernel Control API
*	  Description:      API providing access to control the Kernel
*
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Krnl_Ctrl_H
#define Krnl_Ctrl_H

class Simulation_Scheduler;
class Scenario_Manager;
class Chemistry;
class Reactor;
class Realised_Cycle_Type_Manager;
class Tracker_Manager;

class   Krnl_Ctrl

{
    public:

        static  void Initialise_API();

//      Simulation Scheduler Functions

        static void  Disable_Simulation_Processing();
        static void  Enable_Simulation_Processing();

//      Scenario Manager Functions

        static bool  Load_Scenario_Series(const string& PathName, string&  Error_Tx);

//      Scenario Functions

        static void  Close_Scenario();

    private:

        static Simulation_Scheduler*  Sim_Scheduler_Pt;
        static Scenario_Manager*      Scenario_Mgr_Pt;
        static Chemistry*             Chem_Pt;
        static Reactor*               Reactor_Pt;
        static Realised_Cycle_Type_Manager*  RCT_Mgr_Pt;
        static Tracker_Manager*       Trckr_Mgr_Pt;
};
#endif  //Krnl_Ctrl_H
