/****************************************************************************
*
*	  Header Filename:  Colour.h
*	  Module Name:      Colour
*	  Description:      Colour Settings for use with GTK
*
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
******************************************Template_H**********************************/

#ifndef Colour_H
#define Colour_H

class   Colour

{
//===== Relationships with other classes ===================================================================

//==========================================================================================================


    public:
  
        static  Gdk::Color Blue() {Assert (Instance_Ptr not_eq 0, "Gdk::Color Blue() - No Colour object exists");
                                    return *(Instance_Ptr->Blue_Ptr);}

        static  Gdk::Color Red() {Assert (Instance_Ptr not_eq 0, "Gdk::Color Red() - No Colour object exists");
                                    return *(Instance_Ptr->Red_Ptr);}

        static  Gdk::Color Green() {Assert (Instance_Ptr not_eq 0, "Gdk::Color Green() - No Colour object exists");
                                    return *(Instance_Ptr->Green_Ptr);}

        static  Gdk::Color Black() {Assert (Instance_Ptr not_eq 0, "Gdk::Color Black() - No Colour object exists");
                                    return *(Instance_Ptr->Black_Ptr);}

        static  Gdk::Color White() {Assert (Instance_Ptr not_eq 0, "Gdk::Color White() - No Colour object exists");
                                    return *(Instance_Ptr->White_Ptr);}

        static  Gdk::Color LimeGreen() {Assert (Instance_Ptr not_eq 0, "Gdk::Color LimeGreen() - No Colour object exists");
                                    return *(Instance_Ptr->LimeGreen_Ptr);}

        static  Gdk::Color Maroon() {Assert (Instance_Ptr not_eq 0, "Gdk::Color Maroon() - No Colour object exists");
                                    return *(Instance_Ptr->Maroon_Ptr);}


        Colour(); 
        static Gdk::Color Get_GDK_Colour_RGB(int Red, int Green, int Blue);

    private:
        static  Colour* Instance_Ptr;

        Glib::RefPtr<Gdk::Colormap> ColourMap;

        Gdk::Color*  Blue_Ptr;   //  For some reason, this only works with a pointer
        Gdk::Color*  Red_Ptr; 
        Gdk::Color*  Green_Ptr; 
        Gdk::Color*  Black_Ptr; 
        Gdk::Color*  White_Ptr; 
        Gdk::Color*  LimeGreen_Ptr;
        Gdk::Color*  Maroon_Ptr;
};
#endif  //Colour_H
